/*********************************************************************************************
 * (c) COPYRIGHT 2020 by NetModule AG, Switzerland.  All rights reserved.
 * -------------------------------------------------------------------------------------------
 *
 * InfoWriter-private HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : InfoWriter-private.h
 * CREATION DATE : Nov 18, 2021
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/
#ifndef SRC_INFOWRITER_PRIVATE_H_
#define SRC_INFOWRITER_PRIVATE_H_

#include <nmapp/file/IFileOperation.h>
#include "InfoWriter.h"

#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        PRIVATE DECLARATIONS
 *********************************************************************************************/

#define INFO_DATA_PATH_SIZE             128
#define INFO_DATA_SIZE                 1024
#define INFO_DATA_LINE_SIZE              64


#define INFO_STRING_STATIC_DATA_FMT    "Chip Name:                %s\n"  \
                                       "HW Revision:              %s\n"  \
                                       "Revision:                 %s\n"  \
                                       "FW Version:               %s\n"  \
                                       "Serial Number:            %s\n"  \
                                       "Reliable Writable:        %d\n"  \
                                       "Reliable Write Config:    0x%x\n"

#define INFO_STRING_DYNAMIC_DATA_FMT   "Pre-EOL Information:      %d = %s\n"  \
                                       "Lifetime used (SLC):      %d%%\n"     \
                                       "Lifetime used (MLC):      %d%%\n"     \
                                       "Disk space free:          %.1fMB\n"

#define INFO_STRING_DYNAMIC_DATA_UNSUPPORTED_LIFETIMES_FMT  "Pre-EOL Information:      %d = %s\n"              \
                                                            "Lifetime used (SLC):      Unsupported by eMMC\n"  \
                                                            "Lifetime used (MLC):      Unsupported by eMMC\n"  \
                                                            "Disk space free:          %.1fMB\n"


typedef struct __InfoWriterPrivate
{
    ILogRef               logRef;
    IFileOperationRef     fileOpItf;
    const char*           fileName;
    uint32_t              staticDataFileSize;
} InfoWriterPrivate_t;


/*********************************************************************************************
 *        PRIVATE FUNCTIONS
 *********************************************************************************************/


#ifdef __cplusplus
}
#endif

#endif /* SRC_INFOWRITER_PRIVATE_H_ */
