/*********************************************************************************************
 * (c) COPYRIGHT 2021 by NetModule AG, Switzerland
 * -------------------------------------------------------------------------------------------
 *
 * storage-detector-private HEADER
 *
 * -------------------------------------------------------------------------------------------
 *
 * FILENAME      : storage-detector-private.h
 * CREATION DATE : Oct 28, 2021
 * TARGET        : embedded Linux
 *
 *********************************************************************************************/
#ifndef SRC_STORAGEDETECTOR_PRIVATE_H_
#define SRC_STORAGEDETECTOR_PRIVATE_H_

#include "StorageDetector.h"

#ifdef __cplusplus
extern "C" {
#endif


/*********************************************************************************************
 *        PRIVATE DECLARATIONS
 *********************************************************************************************/

typedef void (*StorageDetectorGetLinkPathFn)(StorageDetectorRef me, const char *linkPath, char* linkTarget, uint32_t maxLinkTargetLen);

#define MMCDEV_BUF_SIZE   64

typedef struct __StorageDetector
{
    ILogRef                         logRef;
    StorageDetectorGetLinkPathFn    getLinkTargetPathFn;
    char                            mmcDevice[MMCDEV_BUF_SIZE];
    char                            mmcDeviceInfoPath[MMCDEV_BUF_SIZE];
} StorageDetector_t;




/*********************************************************************************************
 *        PRIVATE FUNCTIONS
 *********************************************************************************************/
//--------------------------------------------------------------------------------------------
void getLinkTargetOfStorage(StorageDetectorRef me, const char *linkPath, char* linkTarget, uint32_t maxLinkTargetLen);

#ifdef __cplusplus
}
#endif

#endif /* SRC_STORAGEDETECTOR_PRIVATE_H_ */
